<template>
    <section>
        <span style="float: right; position: relative"><router-link to="/publisher/my-contents/new" class="font-weight-bold h5 mb-0"><i class="far fa-plus-square"></i> ADD</router-link> </span>

        <h2>My Contents</h2>

        <template v-if="loading || fail">
            <div class="text-center m-5 p-5">
                <span class="h2" v-if="loading"><i class="fas fa-spinner fa-spin"></i></span>
                <span v-else-if="fail">
                    {{ fail.message }}
                    <br><a href="#" class="btn btn-outline-primary" v-on:click.prevent="loadContents">Retry</a>
                </span>
            </div>
        </template>

        <div class="row mx-auto">

            <template v-for="content in contents">

                <div class="col-md-3 p-1">
                    <div class="card border-primary bg-transparent content-card" style="min-height: 8rem;" v-on:click.prevent="openContent(content.id)">
                        <div class="card-body">
                            <span class="card-title h3">{{ content.name }}</span>
                        </div>

                        <div class="card-footer text-right mb-0 bg-primary text-white">
                            <span class="h4 my-0">
                                <i class="fab fa-android" v-if="content.type === 'android'"></i>
                                <i class="fab fa-telegram" v-else-if="content.type === 'telegram'"></i>
                                <i class="fas fa-globe" v-else-if="content.type === 'website'"></i>
                            </span>
                        </div>

                    </div>
                </div>

            </template>

        </div>


    </section>
</template>

<script>
    export default {
        data: function() {
            return {
                // Contents
                contents: [],

                // Loading flag
                loading: false,

                // fail flag
                fail: false,
            }
        },
        methods: {
            openContent: function (contentId) {
                this.$router.push('/publisher/my-contents/' + contentId);
            },
            loadContents: function() {
                // Show loading
                this.loading = true;

                // Clear previous flags
                this.fail = false;

                // Make the request to server
                axios.get('/api/publisher/content')
                    .then(response => {
                        this.contents = response.data;
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 401) {
                                this.fail = {
                                    'message': 'Unauthorized'
                                };
                            } else {
                                this.fail = {
                                    message: 'Something Went Wrong. Check your connection and try again.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Something Went Wrong. Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something Went Wrong. Check your connection and try again.'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.loading = false;
                    });
            }
        },
        mounted() {
            console.log('Publisher - My Contents mounted.');

            // Load the contents
            this.loadContents();
        }
    }
</script>
